module isotoserial;

import std.string : toStringz, fromStringz;
import std.exception;
import std.conv : to;
import std.stdint;

extern(C) {
	struct iso_extract_handle;
	alias iso_listing_callback = int function(void*,const(char)*,int,int,iso_extract_handle*);
	int scan_iso (const(char)* filename, iso_listing_callback callback, void* user_data);
	void extract_file_from_iso (iso_extract_handle*, char*);

	private int printer(void* user_data, const(char)* path, int is_dir, int size, iso_extract_handle* h) {
		auto spath = path.fromStringz;

		if (!is_dir && spath == "/UMD_DATA.BIN") {
			auto buff = new char[size];
			extract_file_from_iso(h, buff.ptr);
			string* out_str = cast(string*)user_data;
			*out_str = buff[0..10].idup;
			return 1;
		}
		else {
			return 0;
		}
	}
}

public string iso_to_serial (string path) {
	// open UMD_DATA.BIN
	// examples:
	// NPEG-00003|8F33052F02B34E56|0001|G
	// NPJH-50465|0D506D389F2AA444|0001|G
	// ULJM-05530|5A2E0CF722EF6299|0001|G

	string retval;
	scan_iso(path.toStringz, &printer, &retval);
	return retval;

	//return "UCES-00356"; //Tekken Dark Resurrection
	//return "NPJH-50465"; //Hatsune Miku (missing from redump list)
	//return "ULJM-05530"; //Undead Knights (missing from redump list)
	//return "NPEG-00003"; //fl0w (missing from redump list)
}
